# macfreeze: exclude Wthreading
# macfreeze: exclude continuation
# macfreeze: exclude readline
# macfreeze: exclude SOCKS
# macfreeze: exclude msvcrt
# macfreeze: exclude rourl2path
# macfreeze: exclude termios

#Main Script for SearchPyDoc Application
#Based on MyApp.py by Dr. Corran Webster
#2001/9/3
#2002/6/10
#--YOSHIMURA Hiroyuki--
__version__ = "0.1"


#############################################################################
# Open rsrc file to run from Python Interpreter.
# See 'Using W Widgets'(http://www.nevada.edu/~cwebster/Python/WWidgets/index.html)
#              by Dr. Corran Webster.
# And see also Python/Mac/Demo/example2.html and Python/Mac/Demo/example2/dnslookup-2.py.
import EasyDialogs
import sys
import string
verStr = string.split(sys.version,' ')[0]
if verStr >= '2.2':
	from Carbon import Res
else:
	EasyDialogs.Message("SearchPyDocPython2.2.1płB\ngpPythoño[Wł͂gpɂȂ܂B")
	sys.exit(1)
	
#############################################################################
RSRC_NAME= 'SearchPyDoc.rsrc'
try:
	dummy = Res.GetResource('CURS', 468)
except Res.Error:
	try:
		Res.FSpOpenResFile(RSRC_NAME, 1)
	except Res.Error:
		EasyDialogs.Message("Cannot open " + RSRC_NAME)
		sys.exit(1) 
#############################################################################

import W
import Wapplication
import FrameWork
import macfs
import MacOS

#from MyDocument import MyDocumentClass
class SearchPyDoc(Wapplication.Application):
	MyCreatorType = '????'		# Creator type of this application
	MyDocumentTypes = ['']	# List of up to four document types recognised
	preffilepath = ":Python:SearchPyDoc Preference"	# Location of prefs in Preferences Folder
	def __init__(self):
		# Standard initialisation.
		Wapplication.Application.__init__(self, self.MyCreatorType)
		
		# All applications should handle these Apple Events,
		#  but you'll need an aete resource.
		from Carbon import AE, AppleEvents
		AE.AEInstallEventHandler(AppleEvents.kCoreEventClass, AppleEvents.kAEOpenApplication, 
				self.ignoreevent)	# We're already open
		AE.AEInstallEventHandler(AppleEvents.kCoreEventClass, AppleEvents.kAEPrintDocuments, 
				self.ignoreevent)	# No printing in this app
		AE.AEInstallEventHandler(AppleEvents.kCoreEventClass, AppleEvents.kAEOpenDocuments, 
				self.opendocsevent)
		AE.AEInstallEventHandler(AppleEvents.kCoreEventClass, AppleEvents.kAEQuitApplication, 
				self.quitevent)

		# If you had a splash screen, it would go here
		# Open documents passed in through argv
###main
		import Apre22PyDocSearch_y
		self.pds = Apre22PyDocSearch_y.PyDocSearch(self)
		# Process some events!
		self.mainloop()
###

	def makeusermenus(self):
		# Set up menu items which all applications should have.
		#   Apple Menu has already been set up.

		# File menu
		m = Wapplication.Menu(self.menubar, "File")
#		newitem = FrameWork.MenuItem(m, "New", "N", 'new')
#		openitem = FrameWork.MenuItem(m, "Open", "O", 'open')
#		FrameWork.Separator(m)
#		closeitem = FrameWork.MenuItem(m, "Close", "W", 'close')
#		saveitem = FrameWork.MenuItem(m, "Save", "S", 'save')
#		saveasitem = FrameWork.MenuItem(m, "Save as", None, 'save_as')
#		FrameWork.Separator(m)
		quititem = FrameWork.MenuItem(m, "Quit", "Q", 'quit')
		
		# Edit menu
		m = Wapplication.Menu(self.menubar, "Edit")
		undoitem = FrameWork.MenuItem(m, "Undo", 'Z', "undo")
		FrameWork.Separator(m)
		cutitem = FrameWork.MenuItem(m, "Cut", 'X', "cut")
		copyitem = FrameWork.MenuItem(m, "Copy", "C", "copy")
		pasteitem = FrameWork.MenuItem(m, "Paste", "V", "paste")
		clearitem = FrameWork.MenuItem(m, "Clear", None,  "clear")
#		FrameWork.Separator(m)
#		selallitem = FrameWork.MenuItem(m, "Select all", "A", "selectall")
#		FrameWork.Separator(m)
		# These menu items need to be updated periodically;
		#   any menu item not handled by the application should be here,
		#   as should any with a "can_" handler.
		self._menustocheck = [
				undoitem, cutitem, copyitem, pasteitem, 
				clearitem]

	# no window menu, so pass
	def checkopenwindowsmenu(self):
		pass

	# Handle Apple Events	
	def ignoreevent(self, theAppleEvent, theReply):
		pass
	
	def quitevent(self, theAppleEvent, theReply):
		import AE
		AE.AEInteractWithUser(50000000)
		self._quit()

	def opendocsevent(self, theAppleEvent, theReply):
		W.SetCursor('watch')
		import aetools
		parameters, args = aetools.unpackevent(theAppleEvent)
		docs = parameters['----']
		if type(docs) <> type([]):
			docs = [docs]
		for doc in docs:
			fss, a = doc.Resolve()
			path = fss.as_pathname()
			self.opendoc(path)

	# Handle menu items
	def do_about(self, id, item, window, event):
		EasyDialogs.Message(self.__class__.__name__ + ' Application ver' + __version__ + '\n on Python' + verStr)

#	def domenu_open(self, *args):
#		# This gives a standard open file dialog.

#	def domenu_new(self, *args):

	def domenu_quit(self):
		# buh-bye
		self.pds.close()	# added by yoshimura
		self._quit()

# Run the app
SearchPyDoc()
